diff --git a/drupal7/sites/all/modules/cas/cas_server.module b/drupal7/sites/all/modules/cas/cas_server.module
index e20a0274..8d7af9ac 100644
--- a/drupal7/sites/all/modules/cas/cas_server.module
+++ b/drupal7/sites/all/modules/cas/cas_server.module
@@ -64,6 +64,10 @@ function cas_server_theme() {
       'variables' => array('ticket' => NULL, 'error_code' => NULL),
       'file' => 'cas_server.response.inc',
     ),
+    'cas_service_logout_request' => array(
+      'variables' => array('ticket' => NULL, 'date' => NULL, 'id' => NULL),
+      'file' => 'cas_server.response.inc',
+    ),
   );
 }
 
@@ -131,6 +135,12 @@ function cas_server_login() {
  * This provides the simple non-xml based
  */
 function cas_server_validate() {
+  // Prevent this page from being cached.
+  drupal_page_is_cacheable(FALSE);
+
+  // Set content type.
+  drupal_add_http_header('Content-Type', 'text/plain; charset=utf-8');
+
   //Obtain the ticket from the url and validate it.
   $ticket = isset($_REQUEST['ticket']) ? $_REQUEST['ticket'] : '';
   $service = isset($_REQUEST['service']) ? $_REQUEST['service'] : '';
@@ -149,13 +159,18 @@ function cas_server_validate() {
  * Returns data in xml
  */
 function cas_server_service_validate() {
+  // Prevent this page from being cached.
+  drupal_page_is_cacheable(FALSE);
+
+  // Set content type.
+  drupal_add_http_header('Content-Type', 'text/xml; charset=utf-8');
+
   $ticket = isset($_REQUEST['ticket']) ? $_REQUEST['ticket'] : '';
   $service = isset($_REQUEST['service']) ? $_REQUEST['service'] : '';
   $user_name = _cas_server_validate($service, $ticket);
   if (!$user_name) $cas_error='INVALID_TICKET';
   if (!$ticket || !$service) $cas_error='INVALID_REQUEST';
 
-  header('Content-type:', 'text/xml');
   if ($user_name) {
     //@TODO Generate proxy granting ticket
     $account = user_load_by_name($user_name);
@@ -189,13 +204,14 @@ function _cas_server_validate($service, $ticket) {
   // Look up the ticket
   $user_name='';
   $ticket_info=array(':service' => $service, ':ticket' => $ticket);
-  $result = db_query_range("SELECT u.name FROM {cas_server_tickets} t JOIN {users} u ON t.uid=u.uid  WHERE t.service = :service and t.ticket = :ticket", 0, 1, $ticket_info);
+  $result = db_query_range("SELECT u.name FROM {cas_server_tickets} t JOIN {users} u ON t.uid=u.uid  WHERE t.service = :service and t.ticket = :ticket AND valid=1", 0, 1, $ticket_info);
   if ($result !== FALSE) {
     foreach ($result as $ticket_data) {
       $user_name = $ticket_data->name;
     }
   }
-  db_delete('cas_server_tickets')
+  db_update('cas_server_tickets')
+    ->fields(array('valid' => 0))
     ->condition('ticket', $ticket)
     ->execute();
 
@@ -211,7 +227,7 @@ function _cas_server_save_ticket($uid, $service) {
   // Generate the ticket
   $time = REQUEST_TIME;
   $ticket = 'ST-' . user_password();
-  $ticket_data = array('uid' => $uid, 'service' => $service, 'ticket' => $ticket, 'timestamp' => $time);
+  $ticket_data = array('uid' => $uid, 'service' => $service, 'ticket' => $ticket, 'timestamp' => $time, 'valid' => 1);
   // Save the ticket to the db
   if ($uid && $service) {
     db_insert('cas_server_tickets')->fields($ticket_data)->execute();
@@ -221,8 +237,6 @@ function _cas_server_save_ticket($uid, $service) {
 
 /**
  * Menu callback; triggers a CAS logout.
- *
- * @TODO: Implement single sign out support
  */
 function cas_server_logout() {
   global $user;
@@ -240,3 +254,49 @@ function cas_server_logout() {
   }
   return $output;
 }
+
+/**
+ * Send CAS a logout requests for each of the user's CAS tickets.
+ *
+ * @param $account
+ *   The user for whom to send CAS logout requests.
+ */
+function cas_server_logout_clients($account) {
+   $result = db_query("SELECT service, ticket, valid FROM {cas_server_tickets} WHERE uid= :uid", array(':uid' => $account->uid));
+    if ($result !== FALSE) {
+      $expired_tickets = array();
+      foreach ($result as $client) {
+        $expired_tickets[] = $client->ticket;
+        if (!$client->valid)  {
+          $id = 'LR-' . user_password();
+          $date = date('c');
+          $logout_request = theme('cas_service_logout_request', array('id' => $id, 'date' => $date, 'ticket' => $client->ticket));
+          // Send POST request
+          $response = drupal_http_request(
+            $client->service,
+            array(
+              'headers' => array('Content-Type' => 'application/x-www-form-urlencoded'),
+              'method' =>  'POST',
+              'data' => 'logoutRequest=' . urlencode($logout_request),
+            )
+          );
+          if (@$response->error) {
+            watchdog('error', 'Error in CAS logout Request - %code : %message', array('%code' => $response->code, '%error' => $response->error));
+          }
+        }
+        // Remove ticket
+      }
+      if ($expired_tickets) {
+        db_delete('cas_server_tickets')
+          ->condition('ticket', $expired_tickets, 'IN')
+          ->execute();
+      }
+    }
+}
+
+/**
+ * Implements hook_user_logout().
+ */
+function cas_server_user_logout($account) {
+  cas_server_logout_clients($account);
+}
diff --git a/drupal7/sites/all/modules/cas/cas_server.response.inc b/drupal7/sites/all/modules/cas/cas_server.response.inc
index 11ae532d..d280dd34 100644
--- a/drupal7/sites/all/modules/cas/cas_server.response.inc
+++ b/drupal7/sites/all/modules/cas/cas_server.response.inc
@@ -15,7 +15,7 @@
  */
 function theme_cas_service_validate_success($variables) {
   $cas_name = $variables['name'];
-  $output .= "<cas:serviceResponse xmlns:cas='http://www.yale.edu/tp/cas'>\n";
+  $output = "<cas:serviceResponse xmlns:cas='http://www.yale.edu/tp/cas'>\n";
   $output .= "<cas:authenticationSuccess>\n";
   $output .= "<cas:user>$cas_name</cas:user>\n";
   $output .= theme('cas_service_validate_attributes', $variables);
@@ -40,7 +40,7 @@ function theme_cas_service_validate_attributes($variables) {
   $style = $variables['style'];
 
   $output = '';
-  switch($style) {
+  switch ($style) {
     case 'jasig':
     default:
       $output .= "<cas:attributes>\n";
@@ -91,3 +91,21 @@ function theme_cas_service_validate_failure($variables) {
 
   return $output;
 }
+
+
+/**
+ * Generate the Single Sign Out request.
+ *
+ * @param unknown_type $variables
+ *   An associative array containing the key, date and logout id request
+ */
+function theme_cas_service_logout_request($variables) {
+  $id = $variables['id'];
+  $date = $variables['date'];
+  $ticket = $variables['ticket'];
+  $output = "<samlp:LogoutRequest xmlns:samlp='urn:oasis:names:tc:SAML:2.0:protocol' ID='$id' Version='2.0' IssueInstant='$date'>\n";
+  $output .= "<saml:NameID xmlns:saml='urn:oasis:names:tc:SAML:2.0:assertion'>@NOT_USED@</saml:NameID>\n";
+  $output .= "<samlp:SessionIndex>$ticket</samlp:SessionIndex>\n";
+  $output .= "</samlp:LogoutRequest>\n";
+  return $output;
+}
diff --git a/drupal7/sites/all/modules/cas/includes/views/handlers/cas_handler_field_cas_name.inc b/drupal7/sites/all/modules/cas/includes/views/handlers/cas_handler_field_cas_name.inc
index 55822de9..f01cd571 100644
--- a/drupal7/sites/all/modules/cas/includes/views/handlers/cas_handler_field_cas_name.inc
+++ b/drupal7/sites/all/modules/cas/includes/views/handlers/cas_handler_field_cas_name.inc
@@ -1,4 +1,10 @@
 <?php
+
+/**
+ * @file
+ * Field handler to provide a list of CAS user names.
+ */
+
 /**
  * Field handler to provide a list of CAS user names.
  */
diff --git a/drupal7/sites/all/modules/cas/tests/cas_test.info b/drupal7/sites/all/modules/cas/tests/cas_test.info
index 8fd4fea8..ad6a00ce 100644
--- a/drupal7/sites/all/modules/cas/tests/cas_test.info
+++ b/drupal7/sites/all/modules/cas/tests/cas_test.info
@@ -8,9 +8,9 @@ hidden = TRUE
 ; code duplication we use several themes defined by that module.
 dependencies[] = cas_server
 
-; Information added by drupal.org packaging script on 2012-05-09
-version = "7.x-1.2"
+; Information added by Drupal.org packaging script on 2014-04-02
+version = "7.x-1.3"
 core = "7.x"
 project = "cas"
-datestamp = "1336595150"
+datestamp = "1396458247"
 
diff --git a/drupal7/sites/all/modules/cas/tests/cas_test.module b/drupal7/sites/all/modules/cas/tests/cas_test.module
index 78b7b9cd..28b83823 100644
--- a/drupal7/sites/all/modules/cas/tests/cas_test.module
+++ b/drupal7/sites/all/modules/cas/tests/cas_test.module
@@ -103,7 +103,7 @@ function cas_test_login() {
 
   if ($cas_user) {
     if (!is_array($cas_user)) {
-      $cas_user = array('name' => $cas_user);
+      $cas_user = array('name' => $cas_user, 'attributes' => array());
     }
     // Generate a ticket and redirect to the service URL with the login ticket.
     $ticket = _cas_test_ticket_generate($service, $cas_user);
@@ -128,6 +128,12 @@ function cas_test_login() {
  * Validate a ticket using the CAS 1.x protocol.
  */
 function cas_test_validate() {
+  // Prevent this page from being cached.
+  drupal_page_is_cacheable(FALSE);
+
+  // Set content type.
+  drupal_add_http_header('Content-Type', 'text/plain; charset=utf-8');
+
   //Obtain the ticket from the url and validate it.
   $ticket = $_GET['ticket'];
   $service = $_GET['service'];
@@ -148,10 +154,15 @@ function cas_test_validate() {
  * Validate a ticket using the CAS 2.0 protocol.
  */
 function cas_test_service_validate() {
+  // Prevent this page from being cached.
+  drupal_page_is_cacheable(FALSE);
+
+  // Set content type.
+  drupal_add_http_header('Content-Type', 'text/xml; charset=utf-8');
+
   $ticket = $_GET['ticket'];
   $service = $_GET['service'];
 
-  header('Content-type:', 'text/xml');
   if ($cas_user = _cas_test_ticket_validate($service, $ticket)) {
     print theme('cas_service_validate_success', $cas_user);
   }
@@ -234,7 +245,7 @@ function _cas_test_ticket_validate($service, $ticket) {
  *
  * @param $cas_user
  */
-function cas_test_single_sign_out($cas_name) {
+function cas_test_single_sign_out($cas_name, $double_encode=FALSE) {
   $sso = variable_get('cas_test_sso', array());
   foreach ($sso[$cas_name] as $service => $tickets) {
     foreach ($tickets as $ticket) {
@@ -243,6 +254,11 @@ function cas_test_single_sign_out($cas_name) {
         'logoutRequest' => t("<samlp:LogoutRequest ID=\"!id\" Version=\"2.0\" IssueInstant=\"!time\">\n<saml:NameID>@NOT_USED@</saml:NameID>\n<samlp:SessionIndex>!ticket</samlp:SessionIndex>\n</samlp:LogoutRequest>", array('!id' => user_password(10), '!time' => time(), '!ticket' => $ticket)),
       );
 
+      if ($double_encode) {
+        // Certain CAS servers urlencode the logoutRequest.
+        $data['logoutRequest'] = urlencode($data['logoutRequest']);
+      }
+
       // Sign out the user.
       $options = array(
         'method' => 'POST',
diff --git a/drupal7/sites/all/modules/print/print.info b/drupal7/sites/all/modules/print/print.info
index 6fa82c61..aba761ab 100644
--- a/drupal7/sites/all/modules/print/print.info
+++ b/drupal7/sites/all/modules/print/print.info
@@ -1,18 +1,14 @@
 name = "Printer-friendly pages"
-description = "Adds a printer-friendly version link to content and administrative pages."
-core=7.x
+description = "Generates a printer-friendly version of Drupal pages."
+core = 7.x
 package = "Printer, email and PDF versions"
-files[] = print.module
-files[] = print.admin.inc
-files[] = print.pages.inc
-files[] = print.install
-files[] = print.views.inc
 files[] = print_join_page_counter.inc
+dependencies[] = node
 configure = admin/config/user-interface/print
 
-; Information added by drupal.org packaging script on 2012-09-04
-version = "7.x-1.2"
+; Information added by Drupal.org packaging script on 2014-04-02
+version = "7.x-1.3"
 core = "7.x"
 project = "print"
-datestamp = "1346768900"
+datestamp = "1396426750"
 
diff --git a/drupal7/sites/all/modules/print/print.install b/drupal7/sites/all/modules/print/print.install
index 2a6f7f24..6406ceab 100644
--- a/drupal7/sites/all/modules/print/print.install
+++ b/drupal7/sites/all/modules/print/print.install
@@ -126,7 +126,7 @@ function print_schema() {
     'fields' => array(
       'path' => array(
         'type' => 'varchar',
-        'length' => 128,
+        'length' => 255,
         'not null' => TRUE,
         'description' => 'Page path',
       ),
@@ -175,3 +175,13 @@ function print_update_7101(&$sandbox) {
   $link_pos['help'] = 'help';
   variable_set('print_html_link_pos', $link_pos);
 }
+
+/**
+ * Increase size of the path field in the print_page_counter table
+ */
+function print_update_7103(&$sandbox) {
+  db_drop_primary_key('print_page_counter');
+  db_change_field('print_page_counter', 'path', 'path',
+    array('type' => 'varchar', 'length' => 255, 'not null' => TRUE, 'description' => 'Page path'),
+    array('primary key' => array('path')));
+}
diff --git a/drupal7/sites/all/modules/print/print.module b/drupal7/sites/all/modules/print/print.module
index d799a826..43d3b609 100644
--- a/drupal7/sites/all/modules/print/print.module
+++ b/drupal7/sites/all/modules/print/print.module
@@ -263,6 +263,8 @@ function print_block_info() {
  * Implements hook_block_view().
  */
 function print_block_view($delta = '') {
+  $block = array();
+
   switch ($delta) {
     case 'print-links':
       $nid = preg_replace('!^node/!', '', $_GET['q']);
@@ -465,9 +467,15 @@ function print_node_insert($node) {
  */
 function print_node_update($node) {
   if (user_access('administer print') || user_access('node-specific print configuration')) {
-    if (!isset($node->print_display)) $node->print_display = variable_get('print_display_' . $node->type, PRINT_TYPE_SHOW_LINK_DEFAULT);
-    if (!isset($node->print_display_comment)) $node->print_display_comment = variable_get('print_display_comment_' . $node->type, PRINT_TYPE_COMMENT_LINK_DEFAULT);
-    if (!isset($node->print_display_urllist)) $node->print_display_urllist = variable_get('print_display_urllist_' . $node->type, PRINT_TYPE_URLLIST_DEFAULT);
+    if (!isset($node->print_display) || $node->print_display === NULL) {
+      $node->print_display = variable_get('print_display_' . $node->type, PRINT_TYPE_SHOW_LINK_DEFAULT);
+    }
+    if (!isset($node->print_display_comment) || $node->print_display_comment === NULL) {
+      $node->print_display_comment = variable_get('print_display_comment_' . $node->type, PRINT_TYPE_COMMENT_LINK_DEFAULT);
+    }
+    if (!isset($node->print_display_urllist) || $node->print_display_urllist === NULL) {
+      $node->print_display_urllist = variable_get('print_display_urllist_' . $node->type, PRINT_TYPE_URLLIST_DEFAULT);
+    }
 
     _print_node_conf_modify($node->nid, $node->print_display, $node->print_display_comment, $node->print_display_urllist);
   }
diff --git a/drupal7/sites/all/modules/print/print.pages.inc b/drupal7/sites/all/modules/print/print.pages.inc
index a7bd7345..f6c7a546 100644
--- a/drupal7/sites/all/modules/print/print.pages.inc
+++ b/drupal7/sites/all/modules/print/print.pages.inc
@@ -193,7 +193,7 @@ function _print_var_generator($node, $query = NULL, $message = NULL, $cid = NULL
   $print['favicon'] = theme_get_setting('toggle_favicon') ? "<link rel='shortcut icon' href='" . theme_get_setting('favicon') . "' type='image/x-icon' />\n" : '';
 
   if (!empty($print_css)) {
-    drupal_add_css(strtr($print_css, array('%t' => path_to_theme())));
+    drupal_add_css(strtr($print_css, array('%t' => drupal_get_path('theme', variable_get('theme_default')))));
   }
   else {
     drupal_add_css(drupal_get_path('module', 'print') . '/css/print.css');
@@ -254,6 +254,9 @@ function _print_var_generator($node, $query = NULL, $message = NULL, $cid = NULL
       $footer = $print_footer_user;
       break;
   }
+  // Delete the contextual links
+  $footer = preg_replace('!\s*<div class="contextual-links-wrapper">.*?</div>!sim', '', $footer);
+
   $print['footer_message'] = filter_xss_admin($footer);
 
   $published_site = variable_get('site_name', 0);
@@ -387,7 +390,7 @@ function _print_rewrite_urls($matches) {
           }
           // Because base href is the original page, change the link to
           // still be usable inside the print page
-          $matches[1] = str_replace($url, base_path() . $_GET['q'] . $url, $matches[1]);
+          $matches[1] = str_replace($url, check_plain(base_path() . $_GET['q'] . $url), $matches[1]);
         }
         else {
           // URL is relative, convert it into absolute URL
@@ -416,7 +419,7 @@ function _print_rewrite_urls($matches) {
     }
   }
 
-  return $ret;
+  return filter_xss_admin($ret);
 }
 
 /**
@@ -671,6 +674,9 @@ function _print_generate_path($path, $query = NULL, $format = PRINT_HTML_FORMAT,
   // Delete any links area
   $node->body = preg_replace('!\s*<div class="links">.*?</div>!sim', '', $node->body);
 
+  // Delete the contextual links also
+  $node->content = preg_replace('!\s*<div class="contextual-links-wrapper">.*?</div>!sim', '', $node->content);
+
   // Check URL list settings
   $_print_urls = _print_url_list_enabled($node, $format);
 
diff --git a/drupal7/sites/all/modules/print/print_join_page_counter.inc b/drupal7/sites/all/modules/print/print_join_page_counter.inc
index e988d6e1..fe73f002 100644
--- a/drupal7/sites/all/modules/print/print_join_page_counter.inc
+++ b/drupal7/sites/all/modules/print/print_join_page_counter.inc
@@ -11,13 +11,15 @@ class print_join_page_counter extends views_join {
   // PHP 4 doesn't call constructors of the base class automatically from a
   // constructor of a derived class. It is your responsibility to propagate
   // the call to constructors upstream where appropriate.
-  function construct($table, $left_table, $left_field, $field, $extra = array(), $type = 'LEFT') {
+  function construct($table = NULL, $left_table = NULL, $left_field = NULL, $field = NULL, $extra = array(), $type = 'LEFT') {
     parent::construct($table, $left_table, $left_field, $field, $extra, $type);
   }
 
   function build_join($select_query, $table, $view_query) {
-    $this->left_field = "CONCAT('node/', " . $this->left_table . '.' . $this->left_field . ')';
-    $this->left_table = NULL;
+    if ($this->left_table) {
+      $this->left_field = "CONCAT('node/', $this->left_table.$this->left_field)";
+      $this->left_table = NULL;
+    }
     parent::build_join($select_query, $table, $view_query);
   }
 }
diff --git a/drupal7/sites/all/modules/print/print_mail/print_mail.inc b/drupal7/sites/all/modules/print/print_mail/print_mail.inc
index 43785a9c..dbfcf657 100644
--- a/drupal7/sites/all/modules/print/print_mail/print_mail.inc
+++ b/drupal7/sites/all/modules/print/print_mail/print_mail.inc
@@ -116,8 +116,8 @@ function print_mail_form($form, &$form_state) {
     '#required' => TRUE,
   );
   if (!empty($title)) {
-    // To prevent useless translation strings, try to translate only node titles
-    if (drupal_substr($path, 0, 5) == 'node/') {
+    // To prevent useless translation strings, try to translate only non-node titles
+    if (drupal_substr($path, 0, 5) != 'node/') {
       $title = t($title);
     }
 
@@ -150,10 +150,6 @@ function print_mail_form($form, &$form_state) {
     '#type' => 'submit',
     '#value' => t('Send email'),
   );
-  $form['btn_clear'] = array(
-    '#type' => 'markup',
-    '#markup' => '<input type="reset" name="clear" id="edit-btn-clear" value="' . t('Clear form') . '" class="form-submit" />',
-  );
   $form['btn_cancel'] = array(
     '#name' => 'cancel',
     '#type' => 'submit',
diff --git a/drupal7/sites/all/modules/print/print_mail/print_mail.info b/drupal7/sites/all/modules/print/print_mail/print_mail.info
index 4d62ebf3..e821e6aa 100644
--- a/drupal7/sites/all/modules/print/print_mail/print_mail.info
+++ b/drupal7/sites/all/modules/print/print_mail/print_mail.info
@@ -1,18 +1,13 @@
 name = "Send by email"
 description = "Provides the capability to send the web page by email"
-core=7.x
+core = 7.x
 package = "Printer, email and PDF versions"
 dependencies[] = print
-files[] = print_mail.module
-files[] = print_mail.inc
-files[] = print_mail.admin.inc
-files[] = print_mail.install
-files[] = print_mail.views.inc
 configure = admin/config/user-interface/print/email
 
-; Information added by drupal.org packaging script on 2012-09-04
-version = "7.x-1.2"
+; Information added by Drupal.org packaging script on 2014-04-02
+version = "7.x-1.3"
 core = "7.x"
 project = "print"
-datestamp = "1346768900"
+datestamp = "1396426750"
 
diff --git a/drupal7/sites/all/modules/print/print_mail/print_mail.install b/drupal7/sites/all/modules/print/print_mail/print_mail.install
index 1b91e057..69cc4646 100644
--- a/drupal7/sites/all/modules/print/print_mail/print_mail.install
+++ b/drupal7/sites/all/modules/print/print_mail/print_mail.install
@@ -115,7 +115,7 @@ function print_mail_schema() {
     'fields' => array(
       'path' => array(
         'type' => 'varchar',
-        'length' => 128,
+        'length' => 255,
         'not null' => TRUE,
         'description' => 'Page path',
       ),
@@ -201,3 +201,13 @@ function print_mail_update_7102(&$sandbox) {
   $link_pos['help'] = 'help';
   variable_set('print_mail_link_pos', $link_pos);
 }
+
+/**
+ * Increase size of the path field in the print_mail_page_counter table
+ */
+function print_mail_update_7103(&$sandbox) {
+  db_drop_primary_key('print_mail_page_counter');
+  db_change_field('print_mail_page_counter', 'path', 'path',
+    array('type' => 'varchar', 'length' => 255, 'not null' => TRUE, 'description' => 'Page path'),
+    array('primary key' => array('path')));
+}
diff --git a/drupal7/sites/all/modules/print/print_mail/print_mail.module b/drupal7/sites/all/modules/print/print_mail/print_mail.module
index 517a9165..29bb2101 100644
--- a/drupal7/sites/all/modules/print/print_mail/print_mail.module
+++ b/drupal7/sites/all/modules/print/print_mail/print_mail.module
@@ -145,6 +145,8 @@ function print_mail_block_info() {
  * Implements hook_block_view().
  */
 function print_mail_block_view($delta = 0) {
+  $block = array();
+
       switch ($delta) {
       case 'print_mail-top':
         $block['subject'] = t('Most emailed');
@@ -278,9 +280,15 @@ function print_mail_node_insert($node) {
  */
 function print_mail_node_update($node) {
   if (user_access('administer print') || user_access('node-specific print configuration')) {
-    if (!isset($node->print_mail_display)) $node->print_mail_display = variable_get('print_mail_display_' . $node->type, PRINT_TYPE_SHOW_LINK_DEFAULT);
-    if (!isset($node->print_mail_display_comment)) $node->print_mail_display_comment = variable_get('print_mail_display_comment_' . $node->type, PRINT_TYPE_COMMENT_LINK_DEFAULT);
-    if (!isset($node->print_mail_display_urllist)) $node->print_mail_display_urllist = variable_get('print_mail_display_urllist_' . $node->type, PRINT_TYPE_URLLIST_DEFAULT);
+    if (!isset($node->print_mail_display) || $node->print_mail_display === NULL) {
+      $node->print_mail_display = variable_get('print_mail_display_' . $node->type, PRINT_TYPE_SHOW_LINK_DEFAULT);
+    }
+    if (!isset($node->print_mail_display_comment) || $node->print_mail_display_comment === NULL) {
+      $node->print_mail_display_comment = variable_get('print_mail_display_comment_' . $node->type, PRINT_TYPE_COMMENT_LINK_DEFAULT);
+    }
+    if (!isset($node->print_mail_display_urllist) || $node->print_mail_display_urllist === NULL) {
+      $node->print_mail_display_urllist = variable_get('print_mail_display_urllist_' . $node->type, PRINT_TYPE_URLLIST_DEFAULT);
+    }
 
     _print_mail_node_conf_modify($node->nid, $node->print_mail_display, $node->print_mail_display_comment, $node->print_mail_display_urllist);
   }
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.admin.inc b/drupal7/sites/all/modules/print/print_pdf/print_pdf.admin.inc
index f10b5c74..581d6c0c 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.admin.inc
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.admin.inc
@@ -260,7 +260,7 @@ function print_pdf_settings() {
   else {
     $form['settings'] = array(
       '#type' => 'markup',
-      '#markup' => '<p>' . t("No PDF generation tool found! Please dowload a supported PHP PDF generation tool. Check this module's INSTALL.txt for more details.") . '</p>',
+      '#markup' => '<p>' . t("No PDF generation tool found! Please download a supported PHP PDF generation tool. Check this module's INSTALL.txt for more details.") . '</p>',
     );
   }
 
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.class.inc b/drupal7/sites/all/modules/print/print_pdf/print_pdf.class.inc
index 9eaa8cf9..b6a4c530 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.class.inc
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.class.inc
@@ -12,8 +12,13 @@
 class PrintTCPDF extends TCPDF {
   public $footer;
 
+  // Display invisible link at the bottom of all pages.
+  public function setTcpdfLink($tcpdflink) {
+    $this->tcpdflink = $tcpdflink;
+  }
+
   // Page footer data
-  public function SetFooterData($arg = '') {
+  public function setFooterContent($arg = '') {
     $this->footer = $arg;
   }
 
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.drush.inc b/drupal7/sites/all/modules/print/print_pdf/print_pdf.drush.inc
index 4ebe9968..dbaa13d3 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.drush.inc
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.drush.inc
@@ -13,12 +13,13 @@
 define('TCPDF_DOWNLOAD_URI', 'http://sourceforge.net/projects/tcpdf/files/latest');
 
 // URI to the the latest dompdf version.. Hardcoded version unfortunately
-define('DOMPDF_DOWNLOAD_URI', 'http://dompdf.googlecode.com/files/dompdf_0-6-0_beta3.tar.gz');
+define('DOMPDF_DOWNLOAD_URI', 'https://github.com/dompdf/dompdf/releases/download/v0.6.1/dompdf-0.6.1.zip');
 
 // wkhtmltopdf is a binary, requiring a different download for each platform
-define('WKHTMLTOPDF_AMD64_DOWNLOAD_URI', 'http://wkhtmltopdf.googlecode.com/files/wkhtmltopdf-0.11.0_rc1-static-amd64.tar.bz2');
-define('WKHTMLTOPDF_I386_DOWNLOAD_URI', 'http://wkhtmltopdf.googlecode.com/files/wkhtmltopdf-0.11.0_rc1-static-i386.tar.bz2');
-define('WKHTMLTOPDF_WIN_DOWNLOAD_URI', 'http://wkhtmltopdf.googlecode.com/files/wkhtmltox-0.11.0_rc1-installer.exe');
+define('WKHTMLTOPDF_AMD64_DOWNLOAD_URI', 'http://downloads.sourceforge.net/project/wkhtmltopdf/0.12.0/wkhtmltox-linux-amd64_0.12.0-03c001d.tar.xz');
+define('WKHTMLTOPDF_I386_DOWNLOAD_URI', 'http://downloads.sourceforge.net/project/wkhtmltopdf/0.12.0/wkhtmltox-linux-i386_0.12.0-03c001d.tar.xz');
+define('WKHTMLTOPDF_WIN64_DOWNLOAD_URI', 'http://downloads.sourceforge.net/project/wkhtmltopdf/0.12.0/wkhtmltox-win64_0.12.0-03c001d.exe');
+define('WKHTMLTOPDF_WIN_DOWNLOAD_URI', 'http://downloads.sourceforge.net/project/wkhtmltopdf/0.12.0/wkhtmltox-win32_0.12.0-03c001d.exe');
 define('WKHTMLTOPDF_OSX_DOWNLOAD_URI', 'http://wkhtmltopdf.googlecode.com/files/wkhtmltopdf-OSX-0.10.0_rc2-static.tar.bz2');
 
 /**
@@ -159,6 +160,10 @@ function _drush_print_pdf_download_extract($filename) {
         // Decompress the tar bz2 archive
         $arch_ret = drush_shell_exec('tar xjf ' . $filename);
         break;
+      case 'application/x-xz':
+        // Decompress the tar xz archive
+        $arch_ret = drush_shell_exec('tar xJf %s', $filename);
+        break;
     }
   }
   else {
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.info b/drupal7/sites/all/modules/print/print_pdf/print_pdf.info
index d6725138..56f59e5d 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.info
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.info
@@ -1,18 +1,14 @@
 name = "PDF version"
 description = "Adds the capability to export pages as PDF."
-core=7.x
+core = 7.x
 package = "Printer, email and PDF versions"
 dependencies[] = print
-files[] = print_pdf.module
-files[] = print_pdf.admin.inc
-files[] = print_pdf.pages.inc
-files[] = print_pdf.install
-files[] = print_pdf.views.inc
+files[] = print_pdf.class.inc
 configure = admin/config/user-interface/print/pdf
 
-; Information added by drupal.org packaging script on 2012-09-04
-version = "7.x-1.2"
+; Information added by Drupal.org packaging script on 2014-04-02
+version = "7.x-1.3"
 core = "7.x"
 project = "print"
-datestamp = "1346768900"
+datestamp = "1396426750"
 
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.install b/drupal7/sites/all/modules/print/print_pdf/print_pdf.install
index c36eac51..13032b5e 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.install
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.install
@@ -103,7 +103,7 @@ function print_pdf_schema() {
     'fields' => array(
       'path' => array(
         'type' => 'varchar',
-        'length' => 128,
+        'length' => 255,
         'not null' => TRUE,
         'description' => 'Page path',
       ),
@@ -155,3 +155,13 @@ function print_pdf_update_7101(&$sandbox) {
   $link_pos['help'] = 'help';
   variable_set('print_pdf_link_pos', $link_pos);
 }
+
+/**
+ * Increase size of the path field in the print_pdf_page_counter table
+ */
+function print_pdf_update_7105(&$sandbox) {
+  db_drop_primary_key('print_pdf_page_counter');
+  db_change_field('print_pdf_page_counter', 'path', 'path',
+    array('type' => 'varchar', 'length' => 255, 'not null' => TRUE, 'description' => 'Page path'),
+    array('primary key' => array('path')));
+}
